/*-------------------------------------------------*\
/                 Guild Demo by Koolguy900095       \
/ This is a quick little demo that teaches you how  \
/ to create a simple guild system. First it checks  \
/ to see if the guild name that the player wants to \
/ create isnt taken then it makes the guild and     \
/ then it puts the guild name after the players.    \
/ So if the guild name is Test their name will have \
/ {Test} after it.                                  \
/---------------------------------------------------\																																																																																																																																																																*/
world/mob = /mob/Player/
mob/Player
	icon = 'Icons.dmi'
	icon_state = "Player"
	Login()
		if(fexists("players/[src.key].sav"))//If the player has a save it loads it
			src.LoadGuild()
		src.loc = locate(1,1,1)
	Logout()
		src.SaveGuild()//When the player logs out it saves the guild he's in

turf/Grass
	icon = 'Icons.dmi'
	icon_state = "Grass"

var/list/Guilds = list()//This defines the list that we store the created guild in
mob/var/list/Guildmembers = list()//This defines the list we store guildmembers in
mob/var/guild//Defines the variable guild
mob
	verb
		World_Say(var/T as text)//Makes it so the player can enter the message he wants to tell the world
			if(!src.guild)
				world << "[src] says: [T]"//If the player is not in a guild it just shows the message
			else
				world << "{[guild]} [src] says: [T]"//If the player is in a guild it just shows the message	with his guild's name infront

		Make_Guild(var/Guildmaking as text)//The var/Guildmaking as text means whatever the player enters is what the variable Guildmaking is
			if(!usr.guild)
				if(Guilds.Find(ckey(Guildmaking)))//Next we check if the guild name is taken
					alert("There is already a guild named this. Pick another name.")//If it is we tell them that is is and to pick another name
				else
					Guilds += ckey(Guildmaking)//If its not we add the new guild's name to the list of created guilds
					src.guild = "[Guildmaking]"//Now we make the players guild variable equal the new quilds name (This will be used when inviting a player to the guild)
					src.verbs += /mob/Guild/verb/Guild_Chat//We give the player the new guild verbs
					src.verbs += /mob/Guild/verb/Guild_Members//We give the player the new guild verbs
					src.verbs += /mob/Guild/verb/Guild_Invite//We give the player the new guild verbs
					src.verbs += /mob/Guild/verb/Guild_Disband//We give the player the new guild verbs
					src.verbs -= /mob/verb/Make_Guild//Now we delete this verb so the player cannot create multiple guilds
			else
				usr << "You already have a guild."
	Guild
		verb
			Guild_Members()
				src << "The following are in your guild:"
				for(var/mob/M in world)//Checks all the players in the world
					if(M.guild == src.guild)//If the player is in the players guild
						src << "[M]"//then is tells the player

			Guild_Chat(var/T as text)//Makes it so the player can enter the message he wants to tell the guildmembers
				for(var/mob/M in world)
					if(M.guild == src.guild)//Makes sure the other players in his guild can head
						M << "[src] says: [T], to the guild."//Gives all the guild members the message

			Leave_Guild()
				switch(alert("Are you sure you want to leave [guild]","","Yes","No"))//We make sure the character wants to leave the guild
					if("Yes")
						for(var/mob/M in world)
							if(M.guild == src.guild)
								M << "[src] has left [guild]."//If he wants to leave the guild it tells all the members he left
						src.guild = null//Then it makes his guild null so he can join other ones

			Guild_Invite(mob/M as mob in view())//We make it so only players around the player can be invited to the guild
				if(!M.guild)//Now we have sure they are not in a guild
					switch(alert(M,"[usr] would like you to join their guild [usr.guild]. Would you like to join?","","Yes","No"))//If they arent in a guild we ask them to join
						if("Yes")
							src << "[M] has joined [usr.guild]!"//Since he chose yes we tell the player that the new player has joined the guild
							src.Guildmembers += M//We add the new guildmember to the list
							M << "You have joined [usr.guild]!"//We tell the player he has joined
							M.guild = usr.guild//Now we make the players guild the same as the other players
							M.verbs += /mob/Guild/verb/Leave_Guild//We give the player the new guild verbs
							M.verbs += /mob/Guild/verb/Guild_Chat//We give the player the new guild verbs
							M.verbs += /mob/Guild/verb/Guild_Members//We give the player the new guild verbs
							M.verbs -= /mob/Guild/verb/Guild_Chat//We give the player the new guild verbs
							M.verbs -= /mob/Guild/verb/Guild_Members//We give the player the new guild verbs
				else
					usr << "[M] is already in a guild."//If they are in a guild we dont invite them and it tells the player that person is already in a guild

			Guild_Disband()
				switch(alert("Are you sure you want to delete [guild]?","","Yes","No"))//Makes sure the player really wants to disband his guild
					if("Yes")
						for(var/mob/M in Guildmembers)//If he wants to it makes all the players in the guild leave
							M.guild = null//Makes their guild = nothing
						src.verbs -= new/mob/Guild/verb/Guild_Invite//Deletes the owner of the guilds verbs
						src.verbs -= new/mob/Guild/verb/Guild_Disband//Deletes the owner of the guilds verbs
						src.verbs -= new/mob/Guild/verb/Guild_Chat//Deletes the owner of the guilds verbs
						src.verbs -= new/mob/Guild/verb/Guild_Members//Deletes the owner of the guilds verbs
						src.verbs += new/mob/verb/Make_Guild//Gives him the make guild verb so he cant create another one later
						src.guild = null//Makes the owners guild = nothing
						src.Guildmembers = null//Make the guildmembers list = nothing so no more info is stored in it
